import { HttpRequest as __HttpRequest } from "@aws-sdk/protocol-http";
import { decorateServiceException as __decorateServiceException, expectBoolean as __expectBoolean, expectInt32 as __expectInt32, expectString as __expectString, limitedParseDouble as __limitedParseDouble, serializeFloat as __serializeFloat, throwDefaultError, } from "@aws-sdk/smithy-client";
import { CostExplorerServiceException as __BaseException } from "../models/CostExplorerServiceException";
import { BillExpirationException, DataUnavailableException, GenerationExistsException, InvalidNextTokenException, LimitExceededException, RequestChangedException, ResourceNotFoundException, ServiceQuotaExceededException, TooManyTagsException, UnknownMonitorException, UnknownSubscriptionException, UnresolvableUsageUnitException, } from "../models/models_0";
export const se_CreateAnomalyMonitorCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.CreateAnomalyMonitor",
    };
    let body;
    body = JSON.stringify(se_CreateAnomalyMonitorRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_CreateAnomalySubscriptionCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.CreateAnomalySubscription",
    };
    let body;
    body = JSON.stringify(se_CreateAnomalySubscriptionRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_CreateCostCategoryDefinitionCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.CreateCostCategoryDefinition",
    };
    let body;
    body = JSON.stringify(se_CreateCostCategoryDefinitionRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DeleteAnomalyMonitorCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.DeleteAnomalyMonitor",
    };
    let body;
    body = JSON.stringify(se_DeleteAnomalyMonitorRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DeleteAnomalySubscriptionCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.DeleteAnomalySubscription",
    };
    let body;
    body = JSON.stringify(se_DeleteAnomalySubscriptionRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DeleteCostCategoryDefinitionCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.DeleteCostCategoryDefinition",
    };
    let body;
    body = JSON.stringify(se_DeleteCostCategoryDefinitionRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_DescribeCostCategoryDefinitionCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.DescribeCostCategoryDefinition",
    };
    let body;
    body = JSON.stringify(se_DescribeCostCategoryDefinitionRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_GetAnomaliesCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetAnomalies",
    };
    let body;
    body = JSON.stringify(se_GetAnomaliesRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_GetAnomalyMonitorsCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetAnomalyMonitors",
    };
    let body;
    body = JSON.stringify(se_GetAnomalyMonitorsRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_GetAnomalySubscriptionsCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetAnomalySubscriptions",
    };
    let body;
    body = JSON.stringify(se_GetAnomalySubscriptionsRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_GetCostAndUsageCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetCostAndUsage",
    };
    let body;
    body = JSON.stringify(se_GetCostAndUsageRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_GetCostAndUsageWithResourcesCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetCostAndUsageWithResources",
    };
    let body;
    body = JSON.stringify(se_GetCostAndUsageWithResourcesRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_GetCostCategoriesCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetCostCategories",
    };
    let body;
    body = JSON.stringify(se_GetCostCategoriesRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_GetCostForecastCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetCostForecast",
    };
    let body;
    body = JSON.stringify(se_GetCostForecastRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_GetDimensionValuesCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetDimensionValues",
    };
    let body;
    body = JSON.stringify(se_GetDimensionValuesRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_GetReservationCoverageCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetReservationCoverage",
    };
    let body;
    body = JSON.stringify(se_GetReservationCoverageRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_GetReservationPurchaseRecommendationCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetReservationPurchaseRecommendation",
    };
    let body;
    body = JSON.stringify(se_GetReservationPurchaseRecommendationRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_GetReservationUtilizationCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetReservationUtilization",
    };
    let body;
    body = JSON.stringify(se_GetReservationUtilizationRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_GetRightsizingRecommendationCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetRightsizingRecommendation",
    };
    let body;
    body = JSON.stringify(se_GetRightsizingRecommendationRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_GetSavingsPlansCoverageCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetSavingsPlansCoverage",
    };
    let body;
    body = JSON.stringify(se_GetSavingsPlansCoverageRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_GetSavingsPlansPurchaseRecommendationCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetSavingsPlansPurchaseRecommendation",
    };
    let body;
    body = JSON.stringify(se_GetSavingsPlansPurchaseRecommendationRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_GetSavingsPlansUtilizationCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetSavingsPlansUtilization",
    };
    let body;
    body = JSON.stringify(se_GetSavingsPlansUtilizationRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_GetSavingsPlansUtilizationDetailsCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetSavingsPlansUtilizationDetails",
    };
    let body;
    body = JSON.stringify(se_GetSavingsPlansUtilizationDetailsRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_GetTagsCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetTags",
    };
    let body;
    body = JSON.stringify(se_GetTagsRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_GetUsageForecastCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetUsageForecast",
    };
    let body;
    body = JSON.stringify(se_GetUsageForecastRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_ListCostAllocationTagsCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.ListCostAllocationTags",
    };
    let body;
    body = JSON.stringify(se_ListCostAllocationTagsRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_ListCostCategoryDefinitionsCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.ListCostCategoryDefinitions",
    };
    let body;
    body = JSON.stringify(se_ListCostCategoryDefinitionsRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_ListSavingsPlansPurchaseRecommendationGenerationCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.ListSavingsPlansPurchaseRecommendationGeneration",
    };
    let body;
    body = JSON.stringify(se_ListSavingsPlansPurchaseRecommendationGenerationRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_ListTagsForResourceCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.ListTagsForResource",
    };
    let body;
    body = JSON.stringify(se_ListTagsForResourceRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_ProvideAnomalyFeedbackCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.ProvideAnomalyFeedback",
    };
    let body;
    body = JSON.stringify(se_ProvideAnomalyFeedbackRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_StartSavingsPlansPurchaseRecommendationGenerationCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.StartSavingsPlansPurchaseRecommendationGeneration",
    };
    let body;
    body = JSON.stringify(se_StartSavingsPlansPurchaseRecommendationGenerationRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_TagResourceCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.TagResource",
    };
    let body;
    body = JSON.stringify(se_TagResourceRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_UntagResourceCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.UntagResource",
    };
    let body;
    body = JSON.stringify(se_UntagResourceRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_UpdateAnomalyMonitorCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.UpdateAnomalyMonitor",
    };
    let body;
    body = JSON.stringify(se_UpdateAnomalyMonitorRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_UpdateAnomalySubscriptionCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.UpdateAnomalySubscription",
    };
    let body;
    body = JSON.stringify(se_UpdateAnomalySubscriptionRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_UpdateCostAllocationTagsStatusCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.UpdateCostAllocationTagsStatus",
    };
    let body;
    body = JSON.stringify(se_UpdateCostAllocationTagsStatusRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const se_UpdateCostCategoryDefinitionCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.UpdateCostCategoryDefinition",
    };
    let body;
    body = JSON.stringify(se_UpdateCostCategoryDefinitionRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const de_CreateAnomalyMonitorCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CreateAnomalyMonitorCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_CreateAnomalyMonitorResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_CreateAnomalyMonitorCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_CreateAnomalySubscriptionCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CreateAnomalySubscriptionCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_CreateAnomalySubscriptionResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_CreateAnomalySubscriptionCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        case "UnknownMonitorException":
        case "com.amazonaws.costexplorer#UnknownMonitorException":
            throw await de_UnknownMonitorExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_CreateCostCategoryDefinitionCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_CreateCostCategoryDefinitionCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_CreateCostCategoryDefinitionResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_CreateCostCategoryDefinitionCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.costexplorer#ServiceQuotaExceededException":
            throw await de_ServiceQuotaExceededExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_DeleteAnomalyMonitorCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_DeleteAnomalyMonitorCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DeleteAnomalyMonitorResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_DeleteAnomalyMonitorCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        case "UnknownMonitorException":
        case "com.amazonaws.costexplorer#UnknownMonitorException":
            throw await de_UnknownMonitorExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_DeleteAnomalySubscriptionCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_DeleteAnomalySubscriptionCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DeleteAnomalySubscriptionResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_DeleteAnomalySubscriptionCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        case "UnknownSubscriptionException":
        case "com.amazonaws.costexplorer#UnknownSubscriptionException":
            throw await de_UnknownSubscriptionExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_DeleteCostCategoryDefinitionCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_DeleteCostCategoryDefinitionCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DeleteCostCategoryDefinitionResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_DeleteCostCategoryDefinitionCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.costexplorer#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_DescribeCostCategoryDefinitionCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_DescribeCostCategoryDefinitionCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_DescribeCostCategoryDefinitionResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_DescribeCostCategoryDefinitionCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.costexplorer#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_GetAnomaliesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_GetAnomaliesCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_GetAnomaliesResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_GetAnomaliesCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await de_InvalidNextTokenExceptionRes(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_GetAnomalyMonitorsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_GetAnomalyMonitorsCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_GetAnomalyMonitorsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_GetAnomalyMonitorsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await de_InvalidNextTokenExceptionRes(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        case "UnknownMonitorException":
        case "com.amazonaws.costexplorer#UnknownMonitorException":
            throw await de_UnknownMonitorExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_GetAnomalySubscriptionsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_GetAnomalySubscriptionsCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_GetAnomalySubscriptionsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_GetAnomalySubscriptionsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await de_InvalidNextTokenExceptionRes(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        case "UnknownSubscriptionException":
        case "com.amazonaws.costexplorer#UnknownSubscriptionException":
            throw await de_UnknownSubscriptionExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_GetCostAndUsageCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_GetCostAndUsageCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_GetCostAndUsageResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_GetCostAndUsageCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BillExpirationException":
        case "com.amazonaws.costexplorer#BillExpirationException":
            throw await de_BillExpirationExceptionRes(parsedOutput, context);
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await de_DataUnavailableExceptionRes(parsedOutput, context);
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await de_InvalidNextTokenExceptionRes(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        case "RequestChangedException":
        case "com.amazonaws.costexplorer#RequestChangedException":
            throw await de_RequestChangedExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_GetCostAndUsageWithResourcesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_GetCostAndUsageWithResourcesCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_GetCostAndUsageWithResourcesResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_GetCostAndUsageWithResourcesCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BillExpirationException":
        case "com.amazonaws.costexplorer#BillExpirationException":
            throw await de_BillExpirationExceptionRes(parsedOutput, context);
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await de_DataUnavailableExceptionRes(parsedOutput, context);
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await de_InvalidNextTokenExceptionRes(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        case "RequestChangedException":
        case "com.amazonaws.costexplorer#RequestChangedException":
            throw await de_RequestChangedExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_GetCostCategoriesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_GetCostCategoriesCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_GetCostCategoriesResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_GetCostCategoriesCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BillExpirationException":
        case "com.amazonaws.costexplorer#BillExpirationException":
            throw await de_BillExpirationExceptionRes(parsedOutput, context);
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await de_DataUnavailableExceptionRes(parsedOutput, context);
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await de_InvalidNextTokenExceptionRes(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        case "RequestChangedException":
        case "com.amazonaws.costexplorer#RequestChangedException":
            throw await de_RequestChangedExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_GetCostForecastCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_GetCostForecastCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_GetCostForecastResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_GetCostForecastCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await de_DataUnavailableExceptionRes(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_GetDimensionValuesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_GetDimensionValuesCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_GetDimensionValuesResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_GetDimensionValuesCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BillExpirationException":
        case "com.amazonaws.costexplorer#BillExpirationException":
            throw await de_BillExpirationExceptionRes(parsedOutput, context);
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await de_DataUnavailableExceptionRes(parsedOutput, context);
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await de_InvalidNextTokenExceptionRes(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        case "RequestChangedException":
        case "com.amazonaws.costexplorer#RequestChangedException":
            throw await de_RequestChangedExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_GetReservationCoverageCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_GetReservationCoverageCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_GetReservationCoverageResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_GetReservationCoverageCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await de_DataUnavailableExceptionRes(parsedOutput, context);
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await de_InvalidNextTokenExceptionRes(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_GetReservationPurchaseRecommendationCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_GetReservationPurchaseRecommendationCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_GetReservationPurchaseRecommendationResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_GetReservationPurchaseRecommendationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await de_DataUnavailableExceptionRes(parsedOutput, context);
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await de_InvalidNextTokenExceptionRes(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_GetReservationUtilizationCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_GetReservationUtilizationCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_GetReservationUtilizationResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_GetReservationUtilizationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await de_DataUnavailableExceptionRes(parsedOutput, context);
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await de_InvalidNextTokenExceptionRes(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_GetRightsizingRecommendationCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_GetRightsizingRecommendationCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_GetRightsizingRecommendationResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_GetRightsizingRecommendationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await de_InvalidNextTokenExceptionRes(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_GetSavingsPlansCoverageCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_GetSavingsPlansCoverageCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_GetSavingsPlansCoverageResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_GetSavingsPlansCoverageCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await de_DataUnavailableExceptionRes(parsedOutput, context);
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await de_InvalidNextTokenExceptionRes(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_GetSavingsPlansPurchaseRecommendationCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_GetSavingsPlansPurchaseRecommendationCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_GetSavingsPlansPurchaseRecommendationResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_GetSavingsPlansPurchaseRecommendationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await de_InvalidNextTokenExceptionRes(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_GetSavingsPlansUtilizationCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_GetSavingsPlansUtilizationCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_GetSavingsPlansUtilizationResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_GetSavingsPlansUtilizationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await de_DataUnavailableExceptionRes(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_GetSavingsPlansUtilizationDetailsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_GetSavingsPlansUtilizationDetailsCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_GetSavingsPlansUtilizationDetailsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_GetSavingsPlansUtilizationDetailsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await de_DataUnavailableExceptionRes(parsedOutput, context);
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await de_InvalidNextTokenExceptionRes(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_GetTagsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_GetTagsCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_GetTagsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_GetTagsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BillExpirationException":
        case "com.amazonaws.costexplorer#BillExpirationException":
            throw await de_BillExpirationExceptionRes(parsedOutput, context);
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await de_DataUnavailableExceptionRes(parsedOutput, context);
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await de_InvalidNextTokenExceptionRes(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        case "RequestChangedException":
        case "com.amazonaws.costexplorer#RequestChangedException":
            throw await de_RequestChangedExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_GetUsageForecastCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_GetUsageForecastCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_GetUsageForecastResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_GetUsageForecastCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await de_DataUnavailableExceptionRes(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        case "UnresolvableUsageUnitException":
        case "com.amazonaws.costexplorer#UnresolvableUsageUnitException":
            throw await de_UnresolvableUsageUnitExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_ListCostAllocationTagsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_ListCostAllocationTagsCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_ListCostAllocationTagsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_ListCostAllocationTagsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await de_InvalidNextTokenExceptionRes(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_ListCostCategoryDefinitionsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_ListCostCategoryDefinitionsCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_ListCostCategoryDefinitionsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_ListCostCategoryDefinitionsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_ListSavingsPlansPurchaseRecommendationGenerationCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_ListSavingsPlansPurchaseRecommendationGenerationCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_ListSavingsPlansPurchaseRecommendationGenerationResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_ListSavingsPlansPurchaseRecommendationGenerationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await de_InvalidNextTokenExceptionRes(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_ListTagsForResourceCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_ListTagsForResourceCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_ListTagsForResourceResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_ListTagsForResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.costexplorer#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_ProvideAnomalyFeedbackCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_ProvideAnomalyFeedbackCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_ProvideAnomalyFeedbackResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_ProvideAnomalyFeedbackCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_StartSavingsPlansPurchaseRecommendationGenerationCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_StartSavingsPlansPurchaseRecommendationGenerationCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_StartSavingsPlansPurchaseRecommendationGenerationResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_StartSavingsPlansPurchaseRecommendationGenerationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "GenerationExistsException":
        case "com.amazonaws.costexplorer#GenerationExistsException":
            throw await de_GenerationExistsExceptionRes(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.costexplorer#ServiceQuotaExceededException":
            throw await de_ServiceQuotaExceededExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_TagResourceCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_TagResourceCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_TagResourceResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_TagResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.costexplorer#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "TooManyTagsException":
        case "com.amazonaws.costexplorer#TooManyTagsException":
            throw await de_TooManyTagsExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_UntagResourceCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_UntagResourceCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_UntagResourceResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_UntagResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.costexplorer#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_UpdateAnomalyMonitorCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_UpdateAnomalyMonitorCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_UpdateAnomalyMonitorResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_UpdateAnomalyMonitorCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        case "UnknownMonitorException":
        case "com.amazonaws.costexplorer#UnknownMonitorException":
            throw await de_UnknownMonitorExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_UpdateAnomalySubscriptionCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_UpdateAnomalySubscriptionCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_UpdateAnomalySubscriptionResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_UpdateAnomalySubscriptionCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        case "UnknownMonitorException":
        case "com.amazonaws.costexplorer#UnknownMonitorException":
            throw await de_UnknownMonitorExceptionRes(parsedOutput, context);
        case "UnknownSubscriptionException":
        case "com.amazonaws.costexplorer#UnknownSubscriptionException":
            throw await de_UnknownSubscriptionExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_UpdateCostAllocationTagsStatusCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_UpdateCostAllocationTagsStatusCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_UpdateCostAllocationTagsStatusResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_UpdateCostAllocationTagsStatusCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const de_UpdateCostCategoryDefinitionCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return de_UpdateCostCategoryDefinitionCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = de_UpdateCostCategoryDefinitionResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const de_UpdateCostCategoryDefinitionCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await de_LimitExceededExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.costexplorer#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.costexplorer#ServiceQuotaExceededException":
            throw await de_ServiceQuotaExceededExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
const de_BillExpirationExceptionRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = de_BillExpirationException(body, context);
    const exception = new BillExpirationException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_DataUnavailableExceptionRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = de_DataUnavailableException(body, context);
    const exception = new DataUnavailableException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_GenerationExistsExceptionRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = de_GenerationExistsException(body, context);
    const exception = new GenerationExistsException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_InvalidNextTokenExceptionRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = de_InvalidNextTokenException(body, context);
    const exception = new InvalidNextTokenException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_LimitExceededExceptionRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = de_LimitExceededException(body, context);
    const exception = new LimitExceededException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_RequestChangedExceptionRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = de_RequestChangedException(body, context);
    const exception = new RequestChangedException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_ResourceNotFoundExceptionRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = de_ResourceNotFoundException(body, context);
    const exception = new ResourceNotFoundException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_ServiceQuotaExceededExceptionRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = de_ServiceQuotaExceededException(body, context);
    const exception = new ServiceQuotaExceededException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_TooManyTagsExceptionRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = de_TooManyTagsException(body, context);
    const exception = new TooManyTagsException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_UnknownMonitorExceptionRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = de_UnknownMonitorException(body, context);
    const exception = new UnknownMonitorException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_UnknownSubscriptionExceptionRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = de_UnknownSubscriptionException(body, context);
    const exception = new UnknownSubscriptionException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const de_UnresolvableUsageUnitExceptionRes = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = de_UnresolvableUsageUnitException(body, context);
    const exception = new UnresolvableUsageUnitException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const se_AnomalyDateInterval = (input, context) => {
    return {
        ...(input.EndDate != null && { EndDate: input.EndDate }),
        ...(input.StartDate != null && { StartDate: input.StartDate }),
    };
};
const se_AnomalyMonitor = (input, context) => {
    return {
        ...(input.CreationDate != null && { CreationDate: input.CreationDate }),
        ...(input.DimensionalValueCount != null && { DimensionalValueCount: input.DimensionalValueCount }),
        ...(input.LastEvaluatedDate != null && { LastEvaluatedDate: input.LastEvaluatedDate }),
        ...(input.LastUpdatedDate != null && { LastUpdatedDate: input.LastUpdatedDate }),
        ...(input.MonitorArn != null && { MonitorArn: input.MonitorArn }),
        ...(input.MonitorDimension != null && { MonitorDimension: input.MonitorDimension }),
        ...(input.MonitorName != null && { MonitorName: input.MonitorName }),
        ...(input.MonitorSpecification != null && {
            MonitorSpecification: se_Expression(input.MonitorSpecification, context),
        }),
        ...(input.MonitorType != null && { MonitorType: input.MonitorType }),
    };
};
const se_AnomalySubscription = (input, context) => {
    return {
        ...(input.AccountId != null && { AccountId: input.AccountId }),
        ...(input.Frequency != null && { Frequency: input.Frequency }),
        ...(input.MonitorArnList != null && { MonitorArnList: se_MonitorArnList(input.MonitorArnList, context) }),
        ...(input.Subscribers != null && { Subscribers: se_Subscribers(input.Subscribers, context) }),
        ...(input.SubscriptionArn != null && { SubscriptionArn: input.SubscriptionArn }),
        ...(input.SubscriptionName != null && { SubscriptionName: input.SubscriptionName }),
        ...(input.Threshold != null && { Threshold: __serializeFloat(input.Threshold) }),
        ...(input.ThresholdExpression != null && {
            ThresholdExpression: se_Expression(input.ThresholdExpression, context),
        }),
    };
};
const se_CostAllocationTagKeyList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const se_CostAllocationTagStatusEntry = (input, context) => {
    return {
        ...(input.Status != null && { Status: input.Status }),
        ...(input.TagKey != null && { TagKey: input.TagKey }),
    };
};
const se_CostAllocationTagStatusList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return se_CostAllocationTagStatusEntry(entry, context);
    });
};
const se_CostCategoryInheritedValueDimension = (input, context) => {
    return {
        ...(input.DimensionKey != null && { DimensionKey: input.DimensionKey }),
        ...(input.DimensionName != null && { DimensionName: input.DimensionName }),
    };
};
const se_CostCategoryRule = (input, context) => {
    return {
        ...(input.InheritedValue != null && {
            InheritedValue: se_CostCategoryInheritedValueDimension(input.InheritedValue, context),
        }),
        ...(input.Rule != null && { Rule: se_Expression(input.Rule, context) }),
        ...(input.Type != null && { Type: input.Type }),
        ...(input.Value != null && { Value: input.Value }),
    };
};
const se_CostCategoryRulesList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return se_CostCategoryRule(entry, context);
    });
};
const se_CostCategorySplitChargeRule = (input, context) => {
    return {
        ...(input.Method != null && { Method: input.Method }),
        ...(input.Parameters != null && {
            Parameters: se_CostCategorySplitChargeRuleParametersList(input.Parameters, context),
        }),
        ...(input.Source != null && { Source: input.Source }),
        ...(input.Targets != null && { Targets: se_CostCategorySplitChargeRuleTargetsList(input.Targets, context) }),
    };
};
const se_CostCategorySplitChargeRuleParameter = (input, context) => {
    return {
        ...(input.Type != null && { Type: input.Type }),
        ...(input.Values != null && { Values: se_CostCategorySplitChargeRuleParameterValuesList(input.Values, context) }),
    };
};
const se_CostCategorySplitChargeRuleParametersList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return se_CostCategorySplitChargeRuleParameter(entry, context);
    });
};
const se_CostCategorySplitChargeRuleParameterValuesList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const se_CostCategorySplitChargeRulesList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return se_CostCategorySplitChargeRule(entry, context);
    });
};
const se_CostCategorySplitChargeRuleTargetsList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const se_CostCategoryValues = (input, context) => {
    return {
        ...(input.Key != null && { Key: input.Key }),
        ...(input.MatchOptions != null && { MatchOptions: se_MatchOptions(input.MatchOptions, context) }),
        ...(input.Values != null && { Values: se_Values(input.Values, context) }),
    };
};
const se_CreateAnomalyMonitorRequest = (input, context) => {
    return {
        ...(input.AnomalyMonitor != null && { AnomalyMonitor: se_AnomalyMonitor(input.AnomalyMonitor, context) }),
        ...(input.ResourceTags != null && { ResourceTags: se_ResourceTagList(input.ResourceTags, context) }),
    };
};
const se_CreateAnomalySubscriptionRequest = (input, context) => {
    return {
        ...(input.AnomalySubscription != null && {
            AnomalySubscription: se_AnomalySubscription(input.AnomalySubscription, context),
        }),
        ...(input.ResourceTags != null && { ResourceTags: se_ResourceTagList(input.ResourceTags, context) }),
    };
};
const se_CreateCostCategoryDefinitionRequest = (input, context) => {
    return {
        ...(input.DefaultValue != null && { DefaultValue: input.DefaultValue }),
        ...(input.EffectiveStart != null && { EffectiveStart: input.EffectiveStart }),
        ...(input.Name != null && { Name: input.Name }),
        ...(input.ResourceTags != null && { ResourceTags: se_ResourceTagList(input.ResourceTags, context) }),
        ...(input.RuleVersion != null && { RuleVersion: input.RuleVersion }),
        ...(input.Rules != null && { Rules: se_CostCategoryRulesList(input.Rules, context) }),
        ...(input.SplitChargeRules != null && {
            SplitChargeRules: se_CostCategorySplitChargeRulesList(input.SplitChargeRules, context),
        }),
    };
};
const se_DateInterval = (input, context) => {
    return {
        ...(input.End != null && { End: input.End }),
        ...(input.Start != null && { Start: input.Start }),
    };
};
const se_DeleteAnomalyMonitorRequest = (input, context) => {
    return {
        ...(input.MonitorArn != null && { MonitorArn: input.MonitorArn }),
    };
};
const se_DeleteAnomalySubscriptionRequest = (input, context) => {
    return {
        ...(input.SubscriptionArn != null && { SubscriptionArn: input.SubscriptionArn }),
    };
};
const se_DeleteCostCategoryDefinitionRequest = (input, context) => {
    return {
        ...(input.CostCategoryArn != null && { CostCategoryArn: input.CostCategoryArn }),
    };
};
const se_DescribeCostCategoryDefinitionRequest = (input, context) => {
    return {
        ...(input.CostCategoryArn != null && { CostCategoryArn: input.CostCategoryArn }),
        ...(input.EffectiveOn != null && { EffectiveOn: input.EffectiveOn }),
    };
};
const se_DimensionValues = (input, context) => {
    return {
        ...(input.Key != null && { Key: input.Key }),
        ...(input.MatchOptions != null && { MatchOptions: se_MatchOptions(input.MatchOptions, context) }),
        ...(input.Values != null && { Values: se_Values(input.Values, context) }),
    };
};
const se_EC2Specification = (input, context) => {
    return {
        ...(input.OfferingClass != null && { OfferingClass: input.OfferingClass }),
    };
};
const se_Expression = (input, context) => {
    return {
        ...(input.And != null && { And: se_Expressions(input.And, context) }),
        ...(input.CostCategories != null && { CostCategories: se_CostCategoryValues(input.CostCategories, context) }),
        ...(input.Dimensions != null && { Dimensions: se_DimensionValues(input.Dimensions, context) }),
        ...(input.Not != null && { Not: se_Expression(input.Not, context) }),
        ...(input.Or != null && { Or: se_Expressions(input.Or, context) }),
        ...(input.Tags != null && { Tags: se_TagValues(input.Tags, context) }),
    };
};
const se_Expressions = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return se_Expression(entry, context);
    });
};
const se_GetAnomaliesRequest = (input, context) => {
    return {
        ...(input.DateInterval != null && { DateInterval: se_AnomalyDateInterval(input.DateInterval, context) }),
        ...(input.Feedback != null && { Feedback: input.Feedback }),
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.MonitorArn != null && { MonitorArn: input.MonitorArn }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.TotalImpact != null && { TotalImpact: se_TotalImpactFilter(input.TotalImpact, context) }),
    };
};
const se_GetAnomalyMonitorsRequest = (input, context) => {
    return {
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.MonitorArnList != null && { MonitorArnList: se_Values(input.MonitorArnList, context) }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
    };
};
const se_GetAnomalySubscriptionsRequest = (input, context) => {
    return {
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.MonitorArn != null && { MonitorArn: input.MonitorArn }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.SubscriptionArnList != null && { SubscriptionArnList: se_Values(input.SubscriptionArnList, context) }),
    };
};
const se_GetCostAndUsageRequest = (input, context) => {
    return {
        ...(input.Filter != null && { Filter: se_Expression(input.Filter, context) }),
        ...(input.Granularity != null && { Granularity: input.Granularity }),
        ...(input.GroupBy != null && { GroupBy: se_GroupDefinitions(input.GroupBy, context) }),
        ...(input.Metrics != null && { Metrics: se_MetricNames(input.Metrics, context) }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.TimePeriod != null && { TimePeriod: se_DateInterval(input.TimePeriod, context) }),
    };
};
const se_GetCostAndUsageWithResourcesRequest = (input, context) => {
    return {
        ...(input.Filter != null && { Filter: se_Expression(input.Filter, context) }),
        ...(input.Granularity != null && { Granularity: input.Granularity }),
        ...(input.GroupBy != null && { GroupBy: se_GroupDefinitions(input.GroupBy, context) }),
        ...(input.Metrics != null && { Metrics: se_MetricNames(input.Metrics, context) }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.TimePeriod != null && { TimePeriod: se_DateInterval(input.TimePeriod, context) }),
    };
};
const se_GetCostCategoriesRequest = (input, context) => {
    return {
        ...(input.CostCategoryName != null && { CostCategoryName: input.CostCategoryName }),
        ...(input.Filter != null && { Filter: se_Expression(input.Filter, context) }),
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.SearchString != null && { SearchString: input.SearchString }),
        ...(input.SortBy != null && { SortBy: se_SortDefinitions(input.SortBy, context) }),
        ...(input.TimePeriod != null && { TimePeriod: se_DateInterval(input.TimePeriod, context) }),
    };
};
const se_GetCostForecastRequest = (input, context) => {
    return {
        ...(input.Filter != null && { Filter: se_Expression(input.Filter, context) }),
        ...(input.Granularity != null && { Granularity: input.Granularity }),
        ...(input.Metric != null && { Metric: input.Metric }),
        ...(input.PredictionIntervalLevel != null && { PredictionIntervalLevel: input.PredictionIntervalLevel }),
        ...(input.TimePeriod != null && { TimePeriod: se_DateInterval(input.TimePeriod, context) }),
    };
};
const se_GetDimensionValuesRequest = (input, context) => {
    return {
        ...(input.Context != null && { Context: input.Context }),
        ...(input.Dimension != null && { Dimension: input.Dimension }),
        ...(input.Filter != null && { Filter: se_Expression(input.Filter, context) }),
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.SearchString != null && { SearchString: input.SearchString }),
        ...(input.SortBy != null && { SortBy: se_SortDefinitions(input.SortBy, context) }),
        ...(input.TimePeriod != null && { TimePeriod: se_DateInterval(input.TimePeriod, context) }),
    };
};
const se_GetReservationCoverageRequest = (input, context) => {
    return {
        ...(input.Filter != null && { Filter: se_Expression(input.Filter, context) }),
        ...(input.Granularity != null && { Granularity: input.Granularity }),
        ...(input.GroupBy != null && { GroupBy: se_GroupDefinitions(input.GroupBy, context) }),
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.Metrics != null && { Metrics: se_MetricNames(input.Metrics, context) }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.SortBy != null && { SortBy: se_SortDefinition(input.SortBy, context) }),
        ...(input.TimePeriod != null && { TimePeriod: se_DateInterval(input.TimePeriod, context) }),
    };
};
const se_GetReservationPurchaseRecommendationRequest = (input, context) => {
    return {
        ...(input.AccountId != null && { AccountId: input.AccountId }),
        ...(input.AccountScope != null && { AccountScope: input.AccountScope }),
        ...(input.Filter != null && { Filter: se_Expression(input.Filter, context) }),
        ...(input.LookbackPeriodInDays != null && { LookbackPeriodInDays: input.LookbackPeriodInDays }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.PageSize != null && { PageSize: input.PageSize }),
        ...(input.PaymentOption != null && { PaymentOption: input.PaymentOption }),
        ...(input.Service != null && { Service: input.Service }),
        ...(input.ServiceSpecification != null && {
            ServiceSpecification: se_ServiceSpecification(input.ServiceSpecification, context),
        }),
        ...(input.TermInYears != null && { TermInYears: input.TermInYears }),
    };
};
const se_GetReservationUtilizationRequest = (input, context) => {
    return {
        ...(input.Filter != null && { Filter: se_Expression(input.Filter, context) }),
        ...(input.Granularity != null && { Granularity: input.Granularity }),
        ...(input.GroupBy != null && { GroupBy: se_GroupDefinitions(input.GroupBy, context) }),
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.SortBy != null && { SortBy: se_SortDefinition(input.SortBy, context) }),
        ...(input.TimePeriod != null && { TimePeriod: se_DateInterval(input.TimePeriod, context) }),
    };
};
const se_GetRightsizingRecommendationRequest = (input, context) => {
    return {
        ...(input.Configuration != null && {
            Configuration: se_RightsizingRecommendationConfiguration(input.Configuration, context),
        }),
        ...(input.Filter != null && { Filter: se_Expression(input.Filter, context) }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.PageSize != null && { PageSize: input.PageSize }),
        ...(input.Service != null && { Service: input.Service }),
    };
};
const se_GetSavingsPlansCoverageRequest = (input, context) => {
    return {
        ...(input.Filter != null && { Filter: se_Expression(input.Filter, context) }),
        ...(input.Granularity != null && { Granularity: input.Granularity }),
        ...(input.GroupBy != null && { GroupBy: se_GroupDefinitions(input.GroupBy, context) }),
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.Metrics != null && { Metrics: se_MetricNames(input.Metrics, context) }),
        ...(input.NextToken != null && { NextToken: input.NextToken }),
        ...(input.SortBy != null && { SortBy: se_SortDefinition(input.SortBy, context) }),
        ...(input.TimePeriod != null && { TimePeriod: se_DateInterval(input.TimePeriod, context) }),
    };
};
const se_GetSavingsPlansPurchaseRecommendationRequest = (input, context) => {
    return {
        ...(input.AccountScope != null && { AccountScope: input.AccountScope }),
        ...(input.Filter != null && { Filter: se_Expression(input.Filter, context) }),
        ...(input.LookbackPeriodInDays != null && { LookbackPeriodInDays: input.LookbackPeriodInDays }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.PageSize != null && { PageSize: input.PageSize }),
        ...(input.PaymentOption != null && { PaymentOption: input.PaymentOption }),
        ...(input.SavingsPlansType != null && { SavingsPlansType: input.SavingsPlansType }),
        ...(input.TermInYears != null && { TermInYears: input.TermInYears }),
    };
};
const se_GetSavingsPlansUtilizationDetailsRequest = (input, context) => {
    return {
        ...(input.DataType != null && { DataType: se_SavingsPlansDataTypes(input.DataType, context) }),
        ...(input.Filter != null && { Filter: se_Expression(input.Filter, context) }),
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.NextToken != null && { NextToken: input.NextToken }),
        ...(input.SortBy != null && { SortBy: se_SortDefinition(input.SortBy, context) }),
        ...(input.TimePeriod != null && { TimePeriod: se_DateInterval(input.TimePeriod, context) }),
    };
};
const se_GetSavingsPlansUtilizationRequest = (input, context) => {
    return {
        ...(input.Filter != null && { Filter: se_Expression(input.Filter, context) }),
        ...(input.Granularity != null && { Granularity: input.Granularity }),
        ...(input.SortBy != null && { SortBy: se_SortDefinition(input.SortBy, context) }),
        ...(input.TimePeriod != null && { TimePeriod: se_DateInterval(input.TimePeriod, context) }),
    };
};
const se_GetTagsRequest = (input, context) => {
    return {
        ...(input.Filter != null && { Filter: se_Expression(input.Filter, context) }),
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.SearchString != null && { SearchString: input.SearchString }),
        ...(input.SortBy != null && { SortBy: se_SortDefinitions(input.SortBy, context) }),
        ...(input.TagKey != null && { TagKey: input.TagKey }),
        ...(input.TimePeriod != null && { TimePeriod: se_DateInterval(input.TimePeriod, context) }),
    };
};
const se_GetUsageForecastRequest = (input, context) => {
    return {
        ...(input.Filter != null && { Filter: se_Expression(input.Filter, context) }),
        ...(input.Granularity != null && { Granularity: input.Granularity }),
        ...(input.Metric != null && { Metric: input.Metric }),
        ...(input.PredictionIntervalLevel != null && { PredictionIntervalLevel: input.PredictionIntervalLevel }),
        ...(input.TimePeriod != null && { TimePeriod: se_DateInterval(input.TimePeriod, context) }),
    };
};
const se_GroupDefinition = (input, context) => {
    return {
        ...(input.Key != null && { Key: input.Key }),
        ...(input.Type != null && { Type: input.Type }),
    };
};
const se_GroupDefinitions = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return se_GroupDefinition(entry, context);
    });
};
const se_ListCostAllocationTagsRequest = (input, context) => {
    return {
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.NextToken != null && { NextToken: input.NextToken }),
        ...(input.Status != null && { Status: input.Status }),
        ...(input.TagKeys != null && { TagKeys: se_CostAllocationTagKeyList(input.TagKeys, context) }),
        ...(input.Type != null && { Type: input.Type }),
    };
};
const se_ListCostCategoryDefinitionsRequest = (input, context) => {
    return {
        ...(input.EffectiveOn != null && { EffectiveOn: input.EffectiveOn }),
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.NextToken != null && { NextToken: input.NextToken }),
    };
};
const se_ListSavingsPlansPurchaseRecommendationGenerationRequest = (input, context) => {
    return {
        ...(input.GenerationStatus != null && { GenerationStatus: input.GenerationStatus }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.PageSize != null && { PageSize: input.PageSize }),
        ...(input.RecommendationIds != null && {
            RecommendationIds: se_RecommendationIdList(input.RecommendationIds, context),
        }),
    };
};
const se_ListTagsForResourceRequest = (input, context) => {
    return {
        ...(input.ResourceArn != null && { ResourceArn: input.ResourceArn }),
    };
};
const se_MatchOptions = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const se_MetricNames = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const se_MonitorArnList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const se_ProvideAnomalyFeedbackRequest = (input, context) => {
    return {
        ...(input.AnomalyId != null && { AnomalyId: input.AnomalyId }),
        ...(input.Feedback != null && { Feedback: input.Feedback }),
    };
};
const se_RecommendationIdList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const se_ResourceTag = (input, context) => {
    return {
        ...(input.Key != null && { Key: input.Key }),
        ...(input.Value != null && { Value: input.Value }),
    };
};
const se_ResourceTagKeyList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const se_ResourceTagList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return se_ResourceTag(entry, context);
    });
};
const se_RightsizingRecommendationConfiguration = (input, context) => {
    return {
        ...(input.BenefitsConsidered != null && { BenefitsConsidered: input.BenefitsConsidered }),
        ...(input.RecommendationTarget != null && { RecommendationTarget: input.RecommendationTarget }),
    };
};
const se_SavingsPlansDataTypes = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const se_ServiceSpecification = (input, context) => {
    return {
        ...(input.EC2Specification != null && { EC2Specification: se_EC2Specification(input.EC2Specification, context) }),
    };
};
const se_SortDefinition = (input, context) => {
    return {
        ...(input.Key != null && { Key: input.Key }),
        ...(input.SortOrder != null && { SortOrder: input.SortOrder }),
    };
};
const se_SortDefinitions = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return se_SortDefinition(entry, context);
    });
};
const se_StartSavingsPlansPurchaseRecommendationGenerationRequest = (input, context) => {
    return {};
};
const se_Subscriber = (input, context) => {
    return {
        ...(input.Address != null && { Address: input.Address }),
        ...(input.Status != null && { Status: input.Status }),
        ...(input.Type != null && { Type: input.Type }),
    };
};
const se_Subscribers = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return se_Subscriber(entry, context);
    });
};
const se_TagResourceRequest = (input, context) => {
    return {
        ...(input.ResourceArn != null && { ResourceArn: input.ResourceArn }),
        ...(input.ResourceTags != null && { ResourceTags: se_ResourceTagList(input.ResourceTags, context) }),
    };
};
const se_TagValues = (input, context) => {
    return {
        ...(input.Key != null && { Key: input.Key }),
        ...(input.MatchOptions != null && { MatchOptions: se_MatchOptions(input.MatchOptions, context) }),
        ...(input.Values != null && { Values: se_Values(input.Values, context) }),
    };
};
const se_TotalImpactFilter = (input, context) => {
    return {
        ...(input.EndValue != null && { EndValue: __serializeFloat(input.EndValue) }),
        ...(input.NumericOperator != null && { NumericOperator: input.NumericOperator }),
        ...(input.StartValue != null && { StartValue: __serializeFloat(input.StartValue) }),
    };
};
const se_UntagResourceRequest = (input, context) => {
    return {
        ...(input.ResourceArn != null && { ResourceArn: input.ResourceArn }),
        ...(input.ResourceTagKeys != null && { ResourceTagKeys: se_ResourceTagKeyList(input.ResourceTagKeys, context) }),
    };
};
const se_UpdateAnomalyMonitorRequest = (input, context) => {
    return {
        ...(input.MonitorArn != null && { MonitorArn: input.MonitorArn }),
        ...(input.MonitorName != null && { MonitorName: input.MonitorName }),
    };
};
const se_UpdateAnomalySubscriptionRequest = (input, context) => {
    return {
        ...(input.Frequency != null && { Frequency: input.Frequency }),
        ...(input.MonitorArnList != null && { MonitorArnList: se_MonitorArnList(input.MonitorArnList, context) }),
        ...(input.Subscribers != null && { Subscribers: se_Subscribers(input.Subscribers, context) }),
        ...(input.SubscriptionArn != null && { SubscriptionArn: input.SubscriptionArn }),
        ...(input.SubscriptionName != null && { SubscriptionName: input.SubscriptionName }),
        ...(input.Threshold != null && { Threshold: __serializeFloat(input.Threshold) }),
        ...(input.ThresholdExpression != null && {
            ThresholdExpression: se_Expression(input.ThresholdExpression, context),
        }),
    };
};
const se_UpdateCostAllocationTagsStatusRequest = (input, context) => {
    return {
        ...(input.CostAllocationTagsStatus != null && {
            CostAllocationTagsStatus: se_CostAllocationTagStatusList(input.CostAllocationTagsStatus, context),
        }),
    };
};
const se_UpdateCostCategoryDefinitionRequest = (input, context) => {
    return {
        ...(input.CostCategoryArn != null && { CostCategoryArn: input.CostCategoryArn }),
        ...(input.DefaultValue != null && { DefaultValue: input.DefaultValue }),
        ...(input.EffectiveStart != null && { EffectiveStart: input.EffectiveStart }),
        ...(input.RuleVersion != null && { RuleVersion: input.RuleVersion }),
        ...(input.Rules != null && { Rules: se_CostCategoryRulesList(input.Rules, context) }),
        ...(input.SplitChargeRules != null && {
            SplitChargeRules: se_CostCategorySplitChargeRulesList(input.SplitChargeRules, context),
        }),
    };
};
const se_Values = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const de_Anomalies = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_Anomaly(entry, context);
    });
    return retVal;
};
const de_Anomaly = (output, context) => {
    return {
        AnomalyEndDate: __expectString(output.AnomalyEndDate),
        AnomalyId: __expectString(output.AnomalyId),
        AnomalyScore: output.AnomalyScore != null ? de_AnomalyScore(output.AnomalyScore, context) : undefined,
        AnomalyStartDate: __expectString(output.AnomalyStartDate),
        DimensionValue: __expectString(output.DimensionValue),
        Feedback: __expectString(output.Feedback),
        Impact: output.Impact != null ? de_Impact(output.Impact, context) : undefined,
        MonitorArn: __expectString(output.MonitorArn),
        RootCauses: output.RootCauses != null ? de_RootCauses(output.RootCauses, context) : undefined,
    };
};
const de_AnomalyMonitor = (output, context) => {
    return {
        CreationDate: __expectString(output.CreationDate),
        DimensionalValueCount: __expectInt32(output.DimensionalValueCount),
        LastEvaluatedDate: __expectString(output.LastEvaluatedDate),
        LastUpdatedDate: __expectString(output.LastUpdatedDate),
        MonitorArn: __expectString(output.MonitorArn),
        MonitorDimension: __expectString(output.MonitorDimension),
        MonitorName: __expectString(output.MonitorName),
        MonitorSpecification: output.MonitorSpecification != null ? de_Expression(output.MonitorSpecification, context) : undefined,
        MonitorType: __expectString(output.MonitorType),
    };
};
const de_AnomalyMonitors = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_AnomalyMonitor(entry, context);
    });
    return retVal;
};
const de_AnomalyScore = (output, context) => {
    return {
        CurrentScore: __limitedParseDouble(output.CurrentScore),
        MaxScore: __limitedParseDouble(output.MaxScore),
    };
};
const de_AnomalySubscription = (output, context) => {
    return {
        AccountId: __expectString(output.AccountId),
        Frequency: __expectString(output.Frequency),
        MonitorArnList: output.MonitorArnList != null ? de_MonitorArnList(output.MonitorArnList, context) : undefined,
        Subscribers: output.Subscribers != null ? de_Subscribers(output.Subscribers, context) : undefined,
        SubscriptionArn: __expectString(output.SubscriptionArn),
        SubscriptionName: __expectString(output.SubscriptionName),
        Threshold: __limitedParseDouble(output.Threshold),
        ThresholdExpression: output.ThresholdExpression != null ? de_Expression(output.ThresholdExpression, context) : undefined,
    };
};
const de_AnomalySubscriptions = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_AnomalySubscription(entry, context);
    });
    return retVal;
};
const de_Attributes = (output, context) => {
    return Object.entries(output).reduce((acc, [key, value]) => {
        if (value === null) {
            return acc;
        }
        acc[key] = __expectString(value);
        return acc;
    }, {});
};
const de_BillExpirationException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const de_CostAllocationTag = (output, context) => {
    return {
        Status: __expectString(output.Status),
        TagKey: __expectString(output.TagKey),
        Type: __expectString(output.Type),
    };
};
const de_CostAllocationTagList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_CostAllocationTag(entry, context);
    });
    return retVal;
};
const de_CostCategory = (output, context) => {
    return {
        CostCategoryArn: __expectString(output.CostCategoryArn),
        DefaultValue: __expectString(output.DefaultValue),
        EffectiveEnd: __expectString(output.EffectiveEnd),
        EffectiveStart: __expectString(output.EffectiveStart),
        Name: __expectString(output.Name),
        ProcessingStatus: output.ProcessingStatus != null
            ? de_CostCategoryProcessingStatusList(output.ProcessingStatus, context)
            : undefined,
        RuleVersion: __expectString(output.RuleVersion),
        Rules: output.Rules != null ? de_CostCategoryRulesList(output.Rules, context) : undefined,
        SplitChargeRules: output.SplitChargeRules != null
            ? de_CostCategorySplitChargeRulesList(output.SplitChargeRules, context)
            : undefined,
    };
};
const de_CostCategoryInheritedValueDimension = (output, context) => {
    return {
        DimensionKey: __expectString(output.DimensionKey),
        DimensionName: __expectString(output.DimensionName),
    };
};
const de_CostCategoryNamesList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const de_CostCategoryProcessingStatus = (output, context) => {
    return {
        Component: __expectString(output.Component),
        Status: __expectString(output.Status),
    };
};
const de_CostCategoryProcessingStatusList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_CostCategoryProcessingStatus(entry, context);
    });
    return retVal;
};
const de_CostCategoryReference = (output, context) => {
    return {
        CostCategoryArn: __expectString(output.CostCategoryArn),
        DefaultValue: __expectString(output.DefaultValue),
        EffectiveEnd: __expectString(output.EffectiveEnd),
        EffectiveStart: __expectString(output.EffectiveStart),
        Name: __expectString(output.Name),
        NumberOfRules: __expectInt32(output.NumberOfRules),
        ProcessingStatus: output.ProcessingStatus != null
            ? de_CostCategoryProcessingStatusList(output.ProcessingStatus, context)
            : undefined,
        Values: output.Values != null ? de_CostCategoryValuesList(output.Values, context) : undefined,
    };
};
const de_CostCategoryReferencesList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_CostCategoryReference(entry, context);
    });
    return retVal;
};
const de_CostCategoryRule = (output, context) => {
    return {
        InheritedValue: output.InheritedValue != null
            ? de_CostCategoryInheritedValueDimension(output.InheritedValue, context)
            : undefined,
        Rule: output.Rule != null ? de_Expression(output.Rule, context) : undefined,
        Type: __expectString(output.Type),
        Value: __expectString(output.Value),
    };
};
const de_CostCategoryRulesList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_CostCategoryRule(entry, context);
    });
    return retVal;
};
const de_CostCategorySplitChargeRule = (output, context) => {
    return {
        Method: __expectString(output.Method),
        Parameters: output.Parameters != null ? de_CostCategorySplitChargeRuleParametersList(output.Parameters, context) : undefined,
        Source: __expectString(output.Source),
        Targets: output.Targets != null ? de_CostCategorySplitChargeRuleTargetsList(output.Targets, context) : undefined,
    };
};
const de_CostCategorySplitChargeRuleParameter = (output, context) => {
    return {
        Type: __expectString(output.Type),
        Values: output.Values != null ? de_CostCategorySplitChargeRuleParameterValuesList(output.Values, context) : undefined,
    };
};
const de_CostCategorySplitChargeRuleParametersList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_CostCategorySplitChargeRuleParameter(entry, context);
    });
    return retVal;
};
const de_CostCategorySplitChargeRuleParameterValuesList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const de_CostCategorySplitChargeRulesList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_CostCategorySplitChargeRule(entry, context);
    });
    return retVal;
};
const de_CostCategorySplitChargeRuleTargetsList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const de_CostCategoryValues = (output, context) => {
    return {
        Key: __expectString(output.Key),
        MatchOptions: output.MatchOptions != null ? de_MatchOptions(output.MatchOptions, context) : undefined,
        Values: output.Values != null ? de_Values(output.Values, context) : undefined,
    };
};
const de_CostCategoryValuesList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const de_Coverage = (output, context) => {
    return {
        CoverageCost: output.CoverageCost != null ? de_CoverageCost(output.CoverageCost, context) : undefined,
        CoverageHours: output.CoverageHours != null ? de_CoverageHours(output.CoverageHours, context) : undefined,
        CoverageNormalizedUnits: output.CoverageNormalizedUnits != null
            ? de_CoverageNormalizedUnits(output.CoverageNormalizedUnits, context)
            : undefined,
    };
};
const de_CoverageByTime = (output, context) => {
    return {
        Groups: output.Groups != null ? de_ReservationCoverageGroups(output.Groups, context) : undefined,
        TimePeriod: output.TimePeriod != null ? de_DateInterval(output.TimePeriod, context) : undefined,
        Total: output.Total != null ? de_Coverage(output.Total, context) : undefined,
    };
};
const de_CoverageCost = (output, context) => {
    return {
        OnDemandCost: __expectString(output.OnDemandCost),
    };
};
const de_CoverageHours = (output, context) => {
    return {
        CoverageHoursPercentage: __expectString(output.CoverageHoursPercentage),
        OnDemandHours: __expectString(output.OnDemandHours),
        ReservedHours: __expectString(output.ReservedHours),
        TotalRunningHours: __expectString(output.TotalRunningHours),
    };
};
const de_CoverageNormalizedUnits = (output, context) => {
    return {
        CoverageNormalizedUnitsPercentage: __expectString(output.CoverageNormalizedUnitsPercentage),
        OnDemandNormalizedUnits: __expectString(output.OnDemandNormalizedUnits),
        ReservedNormalizedUnits: __expectString(output.ReservedNormalizedUnits),
        TotalRunningNormalizedUnits: __expectString(output.TotalRunningNormalizedUnits),
    };
};
const de_CoveragesByTime = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_CoverageByTime(entry, context);
    });
    return retVal;
};
const de_CreateAnomalyMonitorResponse = (output, context) => {
    return {
        MonitorArn: __expectString(output.MonitorArn),
    };
};
const de_CreateAnomalySubscriptionResponse = (output, context) => {
    return {
        SubscriptionArn: __expectString(output.SubscriptionArn),
    };
};
const de_CreateCostCategoryDefinitionResponse = (output, context) => {
    return {
        CostCategoryArn: __expectString(output.CostCategoryArn),
        EffectiveStart: __expectString(output.EffectiveStart),
    };
};
const de_CurrentInstance = (output, context) => {
    return {
        CurrencyCode: __expectString(output.CurrencyCode),
        InstanceName: __expectString(output.InstanceName),
        MonthlyCost: __expectString(output.MonthlyCost),
        OnDemandHoursInLookbackPeriod: __expectString(output.OnDemandHoursInLookbackPeriod),
        ReservationCoveredHoursInLookbackPeriod: __expectString(output.ReservationCoveredHoursInLookbackPeriod),
        ResourceDetails: output.ResourceDetails != null ? de_ResourceDetails(output.ResourceDetails, context) : undefined,
        ResourceId: __expectString(output.ResourceId),
        ResourceUtilization: output.ResourceUtilization != null ? de_ResourceUtilization(output.ResourceUtilization, context) : undefined,
        SavingsPlansCoveredHoursInLookbackPeriod: __expectString(output.SavingsPlansCoveredHoursInLookbackPeriod),
        Tags: output.Tags != null ? de_TagValuesList(output.Tags, context) : undefined,
        TotalRunningHoursInLookbackPeriod: __expectString(output.TotalRunningHoursInLookbackPeriod),
    };
};
const de_DataUnavailableException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const de_DateInterval = (output, context) => {
    return {
        End: __expectString(output.End),
        Start: __expectString(output.Start),
    };
};
const de_DeleteAnomalyMonitorResponse = (output, context) => {
    return {};
};
const de_DeleteAnomalySubscriptionResponse = (output, context) => {
    return {};
};
const de_DeleteCostCategoryDefinitionResponse = (output, context) => {
    return {
        CostCategoryArn: __expectString(output.CostCategoryArn),
        EffectiveEnd: __expectString(output.EffectiveEnd),
    };
};
const de_DescribeCostCategoryDefinitionResponse = (output, context) => {
    return {
        CostCategory: output.CostCategory != null ? de_CostCategory(output.CostCategory, context) : undefined,
    };
};
const de_DimensionValues = (output, context) => {
    return {
        Key: __expectString(output.Key),
        MatchOptions: output.MatchOptions != null ? de_MatchOptions(output.MatchOptions, context) : undefined,
        Values: output.Values != null ? de_Values(output.Values, context) : undefined,
    };
};
const de_DimensionValuesWithAttributes = (output, context) => {
    return {
        Attributes: output.Attributes != null ? de_Attributes(output.Attributes, context) : undefined,
        Value: __expectString(output.Value),
    };
};
const de_DimensionValuesWithAttributesList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_DimensionValuesWithAttributes(entry, context);
    });
    return retVal;
};
const de_DiskResourceUtilization = (output, context) => {
    return {
        DiskReadBytesPerSecond: __expectString(output.DiskReadBytesPerSecond),
        DiskReadOpsPerSecond: __expectString(output.DiskReadOpsPerSecond),
        DiskWriteBytesPerSecond: __expectString(output.DiskWriteBytesPerSecond),
        DiskWriteOpsPerSecond: __expectString(output.DiskWriteOpsPerSecond),
    };
};
const de_EBSResourceUtilization = (output, context) => {
    return {
        EbsReadBytesPerSecond: __expectString(output.EbsReadBytesPerSecond),
        EbsReadOpsPerSecond: __expectString(output.EbsReadOpsPerSecond),
        EbsWriteBytesPerSecond: __expectString(output.EbsWriteBytesPerSecond),
        EbsWriteOpsPerSecond: __expectString(output.EbsWriteOpsPerSecond),
    };
};
const de_EC2InstanceDetails = (output, context) => {
    return {
        AvailabilityZone: __expectString(output.AvailabilityZone),
        CurrentGeneration: __expectBoolean(output.CurrentGeneration),
        Family: __expectString(output.Family),
        InstanceType: __expectString(output.InstanceType),
        Platform: __expectString(output.Platform),
        Region: __expectString(output.Region),
        SizeFlexEligible: __expectBoolean(output.SizeFlexEligible),
        Tenancy: __expectString(output.Tenancy),
    };
};
const de_EC2ResourceDetails = (output, context) => {
    return {
        HourlyOnDemandRate: __expectString(output.HourlyOnDemandRate),
        InstanceType: __expectString(output.InstanceType),
        Memory: __expectString(output.Memory),
        NetworkPerformance: __expectString(output.NetworkPerformance),
        Platform: __expectString(output.Platform),
        Region: __expectString(output.Region),
        Sku: __expectString(output.Sku),
        Storage: __expectString(output.Storage),
        Vcpu: __expectString(output.Vcpu),
    };
};
const de_EC2ResourceUtilization = (output, context) => {
    return {
        DiskResourceUtilization: output.DiskResourceUtilization != null
            ? de_DiskResourceUtilization(output.DiskResourceUtilization, context)
            : undefined,
        EBSResourceUtilization: output.EBSResourceUtilization != null
            ? de_EBSResourceUtilization(output.EBSResourceUtilization, context)
            : undefined,
        MaxCpuUtilizationPercentage: __expectString(output.MaxCpuUtilizationPercentage),
        MaxMemoryUtilizationPercentage: __expectString(output.MaxMemoryUtilizationPercentage),
        MaxStorageUtilizationPercentage: __expectString(output.MaxStorageUtilizationPercentage),
        NetworkResourceUtilization: output.NetworkResourceUtilization != null
            ? de_NetworkResourceUtilization(output.NetworkResourceUtilization, context)
            : undefined,
    };
};
const de_EC2Specification = (output, context) => {
    return {
        OfferingClass: __expectString(output.OfferingClass),
    };
};
const de_ElastiCacheInstanceDetails = (output, context) => {
    return {
        CurrentGeneration: __expectBoolean(output.CurrentGeneration),
        Family: __expectString(output.Family),
        NodeType: __expectString(output.NodeType),
        ProductDescription: __expectString(output.ProductDescription),
        Region: __expectString(output.Region),
        SizeFlexEligible: __expectBoolean(output.SizeFlexEligible),
    };
};
const de_ESInstanceDetails = (output, context) => {
    return {
        CurrentGeneration: __expectBoolean(output.CurrentGeneration),
        InstanceClass: __expectString(output.InstanceClass),
        InstanceSize: __expectString(output.InstanceSize),
        Region: __expectString(output.Region),
        SizeFlexEligible: __expectBoolean(output.SizeFlexEligible),
    };
};
const de_Expression = (output, context) => {
    return {
        And: output.And != null ? de_Expressions(output.And, context) : undefined,
        CostCategories: output.CostCategories != null ? de_CostCategoryValues(output.CostCategories, context) : undefined,
        Dimensions: output.Dimensions != null ? de_DimensionValues(output.Dimensions, context) : undefined,
        Not: output.Not != null ? de_Expression(output.Not, context) : undefined,
        Or: output.Or != null ? de_Expressions(output.Or, context) : undefined,
        Tags: output.Tags != null ? de_TagValues(output.Tags, context) : undefined,
    };
};
const de_Expressions = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_Expression(entry, context);
    });
    return retVal;
};
const de_FindingReasonCodes = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const de_ForecastResult = (output, context) => {
    return {
        MeanValue: __expectString(output.MeanValue),
        PredictionIntervalLowerBound: __expectString(output.PredictionIntervalLowerBound),
        PredictionIntervalUpperBound: __expectString(output.PredictionIntervalUpperBound),
        TimePeriod: output.TimePeriod != null ? de_DateInterval(output.TimePeriod, context) : undefined,
    };
};
const de_ForecastResultsByTime = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_ForecastResult(entry, context);
    });
    return retVal;
};
const de_GenerationExistsException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const de_GenerationSummary = (output, context) => {
    return {
        EstimatedCompletionTime: __expectString(output.EstimatedCompletionTime),
        GenerationCompletionTime: __expectString(output.GenerationCompletionTime),
        GenerationStartedTime: __expectString(output.GenerationStartedTime),
        GenerationStatus: __expectString(output.GenerationStatus),
        RecommendationId: __expectString(output.RecommendationId),
    };
};
const de_GenerationSummaryList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_GenerationSummary(entry, context);
    });
    return retVal;
};
const de_GetAnomaliesResponse = (output, context) => {
    return {
        Anomalies: output.Anomalies != null ? de_Anomalies(output.Anomalies, context) : undefined,
        NextPageToken: __expectString(output.NextPageToken),
    };
};
const de_GetAnomalyMonitorsResponse = (output, context) => {
    return {
        AnomalyMonitors: output.AnomalyMonitors != null ? de_AnomalyMonitors(output.AnomalyMonitors, context) : undefined,
        NextPageToken: __expectString(output.NextPageToken),
    };
};
const de_GetAnomalySubscriptionsResponse = (output, context) => {
    return {
        AnomalySubscriptions: output.AnomalySubscriptions != null ? de_AnomalySubscriptions(output.AnomalySubscriptions, context) : undefined,
        NextPageToken: __expectString(output.NextPageToken),
    };
};
const de_GetCostAndUsageResponse = (output, context) => {
    return {
        DimensionValueAttributes: output.DimensionValueAttributes != null
            ? de_DimensionValuesWithAttributesList(output.DimensionValueAttributes, context)
            : undefined,
        GroupDefinitions: output.GroupDefinitions != null ? de_GroupDefinitions(output.GroupDefinitions, context) : undefined,
        NextPageToken: __expectString(output.NextPageToken),
        ResultsByTime: output.ResultsByTime != null ? de_ResultsByTime(output.ResultsByTime, context) : undefined,
    };
};
const de_GetCostAndUsageWithResourcesResponse = (output, context) => {
    return {
        DimensionValueAttributes: output.DimensionValueAttributes != null
            ? de_DimensionValuesWithAttributesList(output.DimensionValueAttributes, context)
            : undefined,
        GroupDefinitions: output.GroupDefinitions != null ? de_GroupDefinitions(output.GroupDefinitions, context) : undefined,
        NextPageToken: __expectString(output.NextPageToken),
        ResultsByTime: output.ResultsByTime != null ? de_ResultsByTime(output.ResultsByTime, context) : undefined,
    };
};
const de_GetCostCategoriesResponse = (output, context) => {
    return {
        CostCategoryNames: output.CostCategoryNames != null ? de_CostCategoryNamesList(output.CostCategoryNames, context) : undefined,
        CostCategoryValues: output.CostCategoryValues != null ? de_CostCategoryValuesList(output.CostCategoryValues, context) : undefined,
        NextPageToken: __expectString(output.NextPageToken),
        ReturnSize: __expectInt32(output.ReturnSize),
        TotalSize: __expectInt32(output.TotalSize),
    };
};
const de_GetCostForecastResponse = (output, context) => {
    return {
        ForecastResultsByTime: output.ForecastResultsByTime != null
            ? de_ForecastResultsByTime(output.ForecastResultsByTime, context)
            : undefined,
        Total: output.Total != null ? de_MetricValue(output.Total, context) : undefined,
    };
};
const de_GetDimensionValuesResponse = (output, context) => {
    return {
        DimensionValues: output.DimensionValues != null
            ? de_DimensionValuesWithAttributesList(output.DimensionValues, context)
            : undefined,
        NextPageToken: __expectString(output.NextPageToken),
        ReturnSize: __expectInt32(output.ReturnSize),
        TotalSize: __expectInt32(output.TotalSize),
    };
};
const de_GetReservationCoverageResponse = (output, context) => {
    return {
        CoveragesByTime: output.CoveragesByTime != null ? de_CoveragesByTime(output.CoveragesByTime, context) : undefined,
        NextPageToken: __expectString(output.NextPageToken),
        Total: output.Total != null ? de_Coverage(output.Total, context) : undefined,
    };
};
const de_GetReservationPurchaseRecommendationResponse = (output, context) => {
    return {
        Metadata: output.Metadata != null ? de_ReservationPurchaseRecommendationMetadata(output.Metadata, context) : undefined,
        NextPageToken: __expectString(output.NextPageToken),
        Recommendations: output.Recommendations != null
            ? de_ReservationPurchaseRecommendations(output.Recommendations, context)
            : undefined,
    };
};
const de_GetReservationUtilizationResponse = (output, context) => {
    return {
        NextPageToken: __expectString(output.NextPageToken),
        Total: output.Total != null ? de_ReservationAggregates(output.Total, context) : undefined,
        UtilizationsByTime: output.UtilizationsByTime != null ? de_UtilizationsByTime(output.UtilizationsByTime, context) : undefined,
    };
};
const de_GetRightsizingRecommendationResponse = (output, context) => {
    return {
        Configuration: output.Configuration != null
            ? de_RightsizingRecommendationConfiguration(output.Configuration, context)
            : undefined,
        Metadata: output.Metadata != null ? de_RightsizingRecommendationMetadata(output.Metadata, context) : undefined,
        NextPageToken: __expectString(output.NextPageToken),
        RightsizingRecommendations: output.RightsizingRecommendations != null
            ? de_RightsizingRecommendationList(output.RightsizingRecommendations, context)
            : undefined,
        Summary: output.Summary != null ? de_RightsizingRecommendationSummary(output.Summary, context) : undefined,
    };
};
const de_GetSavingsPlansCoverageResponse = (output, context) => {
    return {
        NextToken: __expectString(output.NextToken),
        SavingsPlansCoverages: output.SavingsPlansCoverages != null
            ? de_SavingsPlansCoverages(output.SavingsPlansCoverages, context)
            : undefined,
    };
};
const de_GetSavingsPlansPurchaseRecommendationResponse = (output, context) => {
    return {
        Metadata: output.Metadata != null ? de_SavingsPlansPurchaseRecommendationMetadata(output.Metadata, context) : undefined,
        NextPageToken: __expectString(output.NextPageToken),
        SavingsPlansPurchaseRecommendation: output.SavingsPlansPurchaseRecommendation != null
            ? de_SavingsPlansPurchaseRecommendation(output.SavingsPlansPurchaseRecommendation, context)
            : undefined,
    };
};
const de_GetSavingsPlansUtilizationDetailsResponse = (output, context) => {
    return {
        NextToken: __expectString(output.NextToken),
        SavingsPlansUtilizationDetails: output.SavingsPlansUtilizationDetails != null
            ? de_SavingsPlansUtilizationDetails(output.SavingsPlansUtilizationDetails, context)
            : undefined,
        TimePeriod: output.TimePeriod != null ? de_DateInterval(output.TimePeriod, context) : undefined,
        Total: output.Total != null ? de_SavingsPlansUtilizationAggregates(output.Total, context) : undefined,
    };
};
const de_GetSavingsPlansUtilizationResponse = (output, context) => {
    return {
        SavingsPlansUtilizationsByTime: output.SavingsPlansUtilizationsByTime != null
            ? de_SavingsPlansUtilizationsByTime(output.SavingsPlansUtilizationsByTime, context)
            : undefined,
        Total: output.Total != null ? de_SavingsPlansUtilizationAggregates(output.Total, context) : undefined,
    };
};
const de_GetTagsResponse = (output, context) => {
    return {
        NextPageToken: __expectString(output.NextPageToken),
        ReturnSize: __expectInt32(output.ReturnSize),
        Tags: output.Tags != null ? de_TagList(output.Tags, context) : undefined,
        TotalSize: __expectInt32(output.TotalSize),
    };
};
const de_GetUsageForecastResponse = (output, context) => {
    return {
        ForecastResultsByTime: output.ForecastResultsByTime != null
            ? de_ForecastResultsByTime(output.ForecastResultsByTime, context)
            : undefined,
        Total: output.Total != null ? de_MetricValue(output.Total, context) : undefined,
    };
};
const de_Group = (output, context) => {
    return {
        Keys: output.Keys != null ? de_Keys(output.Keys, context) : undefined,
        Metrics: output.Metrics != null ? de_Metrics(output.Metrics, context) : undefined,
    };
};
const de_GroupDefinition = (output, context) => {
    return {
        Key: __expectString(output.Key),
        Type: __expectString(output.Type),
    };
};
const de_GroupDefinitions = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_GroupDefinition(entry, context);
    });
    return retVal;
};
const de_Groups = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_Group(entry, context);
    });
    return retVal;
};
const de_Impact = (output, context) => {
    return {
        MaxImpact: __limitedParseDouble(output.MaxImpact),
        TotalActualSpend: __limitedParseDouble(output.TotalActualSpend),
        TotalExpectedSpend: __limitedParseDouble(output.TotalExpectedSpend),
        TotalImpact: __limitedParseDouble(output.TotalImpact),
        TotalImpactPercentage: __limitedParseDouble(output.TotalImpactPercentage),
    };
};
const de_InstanceDetails = (output, context) => {
    return {
        EC2InstanceDetails: output.EC2InstanceDetails != null ? de_EC2InstanceDetails(output.EC2InstanceDetails, context) : undefined,
        ESInstanceDetails: output.ESInstanceDetails != null ? de_ESInstanceDetails(output.ESInstanceDetails, context) : undefined,
        ElastiCacheInstanceDetails: output.ElastiCacheInstanceDetails != null
            ? de_ElastiCacheInstanceDetails(output.ElastiCacheInstanceDetails, context)
            : undefined,
        RDSInstanceDetails: output.RDSInstanceDetails != null ? de_RDSInstanceDetails(output.RDSInstanceDetails, context) : undefined,
        RedshiftInstanceDetails: output.RedshiftInstanceDetails != null
            ? de_RedshiftInstanceDetails(output.RedshiftInstanceDetails, context)
            : undefined,
    };
};
const de_InvalidNextTokenException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const de_Keys = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const de_LimitExceededException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const de_ListCostAllocationTagsResponse = (output, context) => {
    return {
        CostAllocationTags: output.CostAllocationTags != null ? de_CostAllocationTagList(output.CostAllocationTags, context) : undefined,
        NextToken: __expectString(output.NextToken),
    };
};
const de_ListCostCategoryDefinitionsResponse = (output, context) => {
    return {
        CostCategoryReferences: output.CostCategoryReferences != null
            ? de_CostCategoryReferencesList(output.CostCategoryReferences, context)
            : undefined,
        NextToken: __expectString(output.NextToken),
    };
};
const de_ListSavingsPlansPurchaseRecommendationGenerationResponse = (output, context) => {
    return {
        GenerationSummaryList: output.GenerationSummaryList != null
            ? de_GenerationSummaryList(output.GenerationSummaryList, context)
            : undefined,
        NextPageToken: __expectString(output.NextPageToken),
    };
};
const de_ListTagsForResourceResponse = (output, context) => {
    return {
        ResourceTags: output.ResourceTags != null ? de_ResourceTagList(output.ResourceTags, context) : undefined,
    };
};
const de_MatchOptions = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const de_Metrics = (output, context) => {
    return Object.entries(output).reduce((acc, [key, value]) => {
        if (value === null) {
            return acc;
        }
        acc[key] = de_MetricValue(value, context);
        return acc;
    }, {});
};
const de_MetricValue = (output, context) => {
    return {
        Amount: __expectString(output.Amount),
        Unit: __expectString(output.Unit),
    };
};
const de_ModifyRecommendationDetail = (output, context) => {
    return {
        TargetInstances: output.TargetInstances != null ? de_TargetInstancesList(output.TargetInstances, context) : undefined,
    };
};
const de_MonitorArnList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const de_NetworkResourceUtilization = (output, context) => {
    return {
        NetworkInBytesPerSecond: __expectString(output.NetworkInBytesPerSecond),
        NetworkOutBytesPerSecond: __expectString(output.NetworkOutBytesPerSecond),
        NetworkPacketsInPerSecond: __expectString(output.NetworkPacketsInPerSecond),
        NetworkPacketsOutPerSecond: __expectString(output.NetworkPacketsOutPerSecond),
    };
};
const de_PlatformDifferences = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const de_ProvideAnomalyFeedbackResponse = (output, context) => {
    return {
        AnomalyId: __expectString(output.AnomalyId),
    };
};
const de_RDSInstanceDetails = (output, context) => {
    return {
        CurrentGeneration: __expectBoolean(output.CurrentGeneration),
        DatabaseEdition: __expectString(output.DatabaseEdition),
        DatabaseEngine: __expectString(output.DatabaseEngine),
        DeploymentOption: __expectString(output.DeploymentOption),
        Family: __expectString(output.Family),
        InstanceType: __expectString(output.InstanceType),
        LicenseModel: __expectString(output.LicenseModel),
        Region: __expectString(output.Region),
        SizeFlexEligible: __expectBoolean(output.SizeFlexEligible),
    };
};
const de_RedshiftInstanceDetails = (output, context) => {
    return {
        CurrentGeneration: __expectBoolean(output.CurrentGeneration),
        Family: __expectString(output.Family),
        NodeType: __expectString(output.NodeType),
        Region: __expectString(output.Region),
        SizeFlexEligible: __expectBoolean(output.SizeFlexEligible),
    };
};
const de_RequestChangedException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const de_ReservationAggregates = (output, context) => {
    return {
        AmortizedRecurringFee: __expectString(output.AmortizedRecurringFee),
        AmortizedUpfrontFee: __expectString(output.AmortizedUpfrontFee),
        NetRISavings: __expectString(output.NetRISavings),
        OnDemandCostOfRIHoursUsed: __expectString(output.OnDemandCostOfRIHoursUsed),
        PurchasedHours: __expectString(output.PurchasedHours),
        PurchasedUnits: __expectString(output.PurchasedUnits),
        RICostForUnusedHours: __expectString(output.RICostForUnusedHours),
        RealizedSavings: __expectString(output.RealizedSavings),
        TotalActualHours: __expectString(output.TotalActualHours),
        TotalActualUnits: __expectString(output.TotalActualUnits),
        TotalAmortizedFee: __expectString(output.TotalAmortizedFee),
        TotalPotentialRISavings: __expectString(output.TotalPotentialRISavings),
        UnrealizedSavings: __expectString(output.UnrealizedSavings),
        UnusedHours: __expectString(output.UnusedHours),
        UnusedUnits: __expectString(output.UnusedUnits),
        UtilizationPercentage: __expectString(output.UtilizationPercentage),
        UtilizationPercentageInUnits: __expectString(output.UtilizationPercentageInUnits),
    };
};
const de_ReservationCoverageGroup = (output, context) => {
    return {
        Attributes: output.Attributes != null ? de_Attributes(output.Attributes, context) : undefined,
        Coverage: output.Coverage != null ? de_Coverage(output.Coverage, context) : undefined,
    };
};
const de_ReservationCoverageGroups = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_ReservationCoverageGroup(entry, context);
    });
    return retVal;
};
const de_ReservationPurchaseRecommendation = (output, context) => {
    return {
        AccountScope: __expectString(output.AccountScope),
        LookbackPeriodInDays: __expectString(output.LookbackPeriodInDays),
        PaymentOption: __expectString(output.PaymentOption),
        RecommendationDetails: output.RecommendationDetails != null
            ? de_ReservationPurchaseRecommendationDetails(output.RecommendationDetails, context)
            : undefined,
        RecommendationSummary: output.RecommendationSummary != null
            ? de_ReservationPurchaseRecommendationSummary(output.RecommendationSummary, context)
            : undefined,
        ServiceSpecification: output.ServiceSpecification != null ? de_ServiceSpecification(output.ServiceSpecification, context) : undefined,
        TermInYears: __expectString(output.TermInYears),
    };
};
const de_ReservationPurchaseRecommendationDetail = (output, context) => {
    return {
        AccountId: __expectString(output.AccountId),
        AverageNormalizedUnitsUsedPerHour: __expectString(output.AverageNormalizedUnitsUsedPerHour),
        AverageNumberOfInstancesUsedPerHour: __expectString(output.AverageNumberOfInstancesUsedPerHour),
        AverageUtilization: __expectString(output.AverageUtilization),
        CurrencyCode: __expectString(output.CurrencyCode),
        EstimatedBreakEvenInMonths: __expectString(output.EstimatedBreakEvenInMonths),
        EstimatedMonthlyOnDemandCost: __expectString(output.EstimatedMonthlyOnDemandCost),
        EstimatedMonthlySavingsAmount: __expectString(output.EstimatedMonthlySavingsAmount),
        EstimatedMonthlySavingsPercentage: __expectString(output.EstimatedMonthlySavingsPercentage),
        EstimatedReservationCostForLookbackPeriod: __expectString(output.EstimatedReservationCostForLookbackPeriod),
        InstanceDetails: output.InstanceDetails != null ? de_InstanceDetails(output.InstanceDetails, context) : undefined,
        MaximumNormalizedUnitsUsedPerHour: __expectString(output.MaximumNormalizedUnitsUsedPerHour),
        MaximumNumberOfInstancesUsedPerHour: __expectString(output.MaximumNumberOfInstancesUsedPerHour),
        MinimumNormalizedUnitsUsedPerHour: __expectString(output.MinimumNormalizedUnitsUsedPerHour),
        MinimumNumberOfInstancesUsedPerHour: __expectString(output.MinimumNumberOfInstancesUsedPerHour),
        RecommendedNormalizedUnitsToPurchase: __expectString(output.RecommendedNormalizedUnitsToPurchase),
        RecommendedNumberOfInstancesToPurchase: __expectString(output.RecommendedNumberOfInstancesToPurchase),
        RecurringStandardMonthlyCost: __expectString(output.RecurringStandardMonthlyCost),
        UpfrontCost: __expectString(output.UpfrontCost),
    };
};
const de_ReservationPurchaseRecommendationDetails = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_ReservationPurchaseRecommendationDetail(entry, context);
    });
    return retVal;
};
const de_ReservationPurchaseRecommendationMetadata = (output, context) => {
    return {
        GenerationTimestamp: __expectString(output.GenerationTimestamp),
        RecommendationId: __expectString(output.RecommendationId),
    };
};
const de_ReservationPurchaseRecommendations = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_ReservationPurchaseRecommendation(entry, context);
    });
    return retVal;
};
const de_ReservationPurchaseRecommendationSummary = (output, context) => {
    return {
        CurrencyCode: __expectString(output.CurrencyCode),
        TotalEstimatedMonthlySavingsAmount: __expectString(output.TotalEstimatedMonthlySavingsAmount),
        TotalEstimatedMonthlySavingsPercentage: __expectString(output.TotalEstimatedMonthlySavingsPercentage),
    };
};
const de_ReservationUtilizationGroup = (output, context) => {
    return {
        Attributes: output.Attributes != null ? de_Attributes(output.Attributes, context) : undefined,
        Key: __expectString(output.Key),
        Utilization: output.Utilization != null ? de_ReservationAggregates(output.Utilization, context) : undefined,
        Value: __expectString(output.Value),
    };
};
const de_ReservationUtilizationGroups = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_ReservationUtilizationGroup(entry, context);
    });
    return retVal;
};
const de_ResourceDetails = (output, context) => {
    return {
        EC2ResourceDetails: output.EC2ResourceDetails != null ? de_EC2ResourceDetails(output.EC2ResourceDetails, context) : undefined,
    };
};
const de_ResourceNotFoundException = (output, context) => {
    return {
        Message: __expectString(output.Message),
        ResourceName: __expectString(output.ResourceName),
    };
};
const de_ResourceTag = (output, context) => {
    return {
        Key: __expectString(output.Key),
        Value: __expectString(output.Value),
    };
};
const de_ResourceTagList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_ResourceTag(entry, context);
    });
    return retVal;
};
const de_ResourceUtilization = (output, context) => {
    return {
        EC2ResourceUtilization: output.EC2ResourceUtilization != null
            ? de_EC2ResourceUtilization(output.EC2ResourceUtilization, context)
            : undefined,
    };
};
const de_ResultByTime = (output, context) => {
    return {
        Estimated: __expectBoolean(output.Estimated),
        Groups: output.Groups != null ? de_Groups(output.Groups, context) : undefined,
        TimePeriod: output.TimePeriod != null ? de_DateInterval(output.TimePeriod, context) : undefined,
        Total: output.Total != null ? de_Metrics(output.Total, context) : undefined,
    };
};
const de_ResultsByTime = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_ResultByTime(entry, context);
    });
    return retVal;
};
const de_RightsizingRecommendation = (output, context) => {
    return {
        AccountId: __expectString(output.AccountId),
        CurrentInstance: output.CurrentInstance != null ? de_CurrentInstance(output.CurrentInstance, context) : undefined,
        FindingReasonCodes: output.FindingReasonCodes != null ? de_FindingReasonCodes(output.FindingReasonCodes, context) : undefined,
        ModifyRecommendationDetail: output.ModifyRecommendationDetail != null
            ? de_ModifyRecommendationDetail(output.ModifyRecommendationDetail, context)
            : undefined,
        RightsizingType: __expectString(output.RightsizingType),
        TerminateRecommendationDetail: output.TerminateRecommendationDetail != null
            ? de_TerminateRecommendationDetail(output.TerminateRecommendationDetail, context)
            : undefined,
    };
};
const de_RightsizingRecommendationConfiguration = (output, context) => {
    return {
        BenefitsConsidered: __expectBoolean(output.BenefitsConsidered),
        RecommendationTarget: __expectString(output.RecommendationTarget),
    };
};
const de_RightsizingRecommendationList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_RightsizingRecommendation(entry, context);
    });
    return retVal;
};
const de_RightsizingRecommendationMetadata = (output, context) => {
    return {
        AdditionalMetadata: __expectString(output.AdditionalMetadata),
        GenerationTimestamp: __expectString(output.GenerationTimestamp),
        LookbackPeriodInDays: __expectString(output.LookbackPeriodInDays),
        RecommendationId: __expectString(output.RecommendationId),
    };
};
const de_RightsizingRecommendationSummary = (output, context) => {
    return {
        EstimatedTotalMonthlySavingsAmount: __expectString(output.EstimatedTotalMonthlySavingsAmount),
        SavingsCurrencyCode: __expectString(output.SavingsCurrencyCode),
        SavingsPercentage: __expectString(output.SavingsPercentage),
        TotalRecommendationCount: __expectString(output.TotalRecommendationCount),
    };
};
const de_RootCause = (output, context) => {
    return {
        LinkedAccount: __expectString(output.LinkedAccount),
        LinkedAccountName: __expectString(output.LinkedAccountName),
        Region: __expectString(output.Region),
        Service: __expectString(output.Service),
        UsageType: __expectString(output.UsageType),
    };
};
const de_RootCauses = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_RootCause(entry, context);
    });
    return retVal;
};
const de_SavingsPlansAmortizedCommitment = (output, context) => {
    return {
        AmortizedRecurringCommitment: __expectString(output.AmortizedRecurringCommitment),
        AmortizedUpfrontCommitment: __expectString(output.AmortizedUpfrontCommitment),
        TotalAmortizedCommitment: __expectString(output.TotalAmortizedCommitment),
    };
};
const de_SavingsPlansCoverage = (output, context) => {
    return {
        Attributes: output.Attributes != null ? de_Attributes(output.Attributes, context) : undefined,
        Coverage: output.Coverage != null ? de_SavingsPlansCoverageData(output.Coverage, context) : undefined,
        TimePeriod: output.TimePeriod != null ? de_DateInterval(output.TimePeriod, context) : undefined,
    };
};
const de_SavingsPlansCoverageData = (output, context) => {
    return {
        CoveragePercentage: __expectString(output.CoveragePercentage),
        OnDemandCost: __expectString(output.OnDemandCost),
        SpendCoveredBySavingsPlans: __expectString(output.SpendCoveredBySavingsPlans),
        TotalCost: __expectString(output.TotalCost),
    };
};
const de_SavingsPlansCoverages = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_SavingsPlansCoverage(entry, context);
    });
    return retVal;
};
const de_SavingsPlansDetails = (output, context) => {
    return {
        InstanceFamily: __expectString(output.InstanceFamily),
        OfferingId: __expectString(output.OfferingId),
        Region: __expectString(output.Region),
    };
};
const de_SavingsPlansPurchaseRecommendation = (output, context) => {
    return {
        AccountScope: __expectString(output.AccountScope),
        LookbackPeriodInDays: __expectString(output.LookbackPeriodInDays),
        PaymentOption: __expectString(output.PaymentOption),
        SavingsPlansPurchaseRecommendationDetails: output.SavingsPlansPurchaseRecommendationDetails != null
            ? de_SavingsPlansPurchaseRecommendationDetailList(output.SavingsPlansPurchaseRecommendationDetails, context)
            : undefined,
        SavingsPlansPurchaseRecommendationSummary: output.SavingsPlansPurchaseRecommendationSummary != null
            ? de_SavingsPlansPurchaseRecommendationSummary(output.SavingsPlansPurchaseRecommendationSummary, context)
            : undefined,
        SavingsPlansType: __expectString(output.SavingsPlansType),
        TermInYears: __expectString(output.TermInYears),
    };
};
const de_SavingsPlansPurchaseRecommendationDetail = (output, context) => {
    return {
        AccountId: __expectString(output.AccountId),
        CurrencyCode: __expectString(output.CurrencyCode),
        CurrentAverageHourlyOnDemandSpend: __expectString(output.CurrentAverageHourlyOnDemandSpend),
        CurrentMaximumHourlyOnDemandSpend: __expectString(output.CurrentMaximumHourlyOnDemandSpend),
        CurrentMinimumHourlyOnDemandSpend: __expectString(output.CurrentMinimumHourlyOnDemandSpend),
        EstimatedAverageUtilization: __expectString(output.EstimatedAverageUtilization),
        EstimatedMonthlySavingsAmount: __expectString(output.EstimatedMonthlySavingsAmount),
        EstimatedOnDemandCost: __expectString(output.EstimatedOnDemandCost),
        EstimatedOnDemandCostWithCurrentCommitment: __expectString(output.EstimatedOnDemandCostWithCurrentCommitment),
        EstimatedROI: __expectString(output.EstimatedROI),
        EstimatedSPCost: __expectString(output.EstimatedSPCost),
        EstimatedSavingsAmount: __expectString(output.EstimatedSavingsAmount),
        EstimatedSavingsPercentage: __expectString(output.EstimatedSavingsPercentage),
        HourlyCommitmentToPurchase: __expectString(output.HourlyCommitmentToPurchase),
        SavingsPlansDetails: output.SavingsPlansDetails != null ? de_SavingsPlansDetails(output.SavingsPlansDetails, context) : undefined,
        UpfrontCost: __expectString(output.UpfrontCost),
    };
};
const de_SavingsPlansPurchaseRecommendationDetailList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_SavingsPlansPurchaseRecommendationDetail(entry, context);
    });
    return retVal;
};
const de_SavingsPlansPurchaseRecommendationMetadata = (output, context) => {
    return {
        AdditionalMetadata: __expectString(output.AdditionalMetadata),
        GenerationTimestamp: __expectString(output.GenerationTimestamp),
        RecommendationId: __expectString(output.RecommendationId),
    };
};
const de_SavingsPlansPurchaseRecommendationSummary = (output, context) => {
    return {
        CurrencyCode: __expectString(output.CurrencyCode),
        CurrentOnDemandSpend: __expectString(output.CurrentOnDemandSpend),
        DailyCommitmentToPurchase: __expectString(output.DailyCommitmentToPurchase),
        EstimatedMonthlySavingsAmount: __expectString(output.EstimatedMonthlySavingsAmount),
        EstimatedOnDemandCostWithCurrentCommitment: __expectString(output.EstimatedOnDemandCostWithCurrentCommitment),
        EstimatedROI: __expectString(output.EstimatedROI),
        EstimatedSavingsAmount: __expectString(output.EstimatedSavingsAmount),
        EstimatedSavingsPercentage: __expectString(output.EstimatedSavingsPercentage),
        EstimatedTotalCost: __expectString(output.EstimatedTotalCost),
        HourlyCommitmentToPurchase: __expectString(output.HourlyCommitmentToPurchase),
        TotalRecommendationCount: __expectString(output.TotalRecommendationCount),
    };
};
const de_SavingsPlansSavings = (output, context) => {
    return {
        NetSavings: __expectString(output.NetSavings),
        OnDemandCostEquivalent: __expectString(output.OnDemandCostEquivalent),
    };
};
const de_SavingsPlansUtilization = (output, context) => {
    return {
        TotalCommitment: __expectString(output.TotalCommitment),
        UnusedCommitment: __expectString(output.UnusedCommitment),
        UsedCommitment: __expectString(output.UsedCommitment),
        UtilizationPercentage: __expectString(output.UtilizationPercentage),
    };
};
const de_SavingsPlansUtilizationAggregates = (output, context) => {
    return {
        AmortizedCommitment: output.AmortizedCommitment != null
            ? de_SavingsPlansAmortizedCommitment(output.AmortizedCommitment, context)
            : undefined,
        Savings: output.Savings != null ? de_SavingsPlansSavings(output.Savings, context) : undefined,
        Utilization: output.Utilization != null ? de_SavingsPlansUtilization(output.Utilization, context) : undefined,
    };
};
const de_SavingsPlansUtilizationByTime = (output, context) => {
    return {
        AmortizedCommitment: output.AmortizedCommitment != null
            ? de_SavingsPlansAmortizedCommitment(output.AmortizedCommitment, context)
            : undefined,
        Savings: output.Savings != null ? de_SavingsPlansSavings(output.Savings, context) : undefined,
        TimePeriod: output.TimePeriod != null ? de_DateInterval(output.TimePeriod, context) : undefined,
        Utilization: output.Utilization != null ? de_SavingsPlansUtilization(output.Utilization, context) : undefined,
    };
};
const de_SavingsPlansUtilizationDetail = (output, context) => {
    return {
        AmortizedCommitment: output.AmortizedCommitment != null
            ? de_SavingsPlansAmortizedCommitment(output.AmortizedCommitment, context)
            : undefined,
        Attributes: output.Attributes != null ? de_Attributes(output.Attributes, context) : undefined,
        Savings: output.Savings != null ? de_SavingsPlansSavings(output.Savings, context) : undefined,
        SavingsPlanArn: __expectString(output.SavingsPlanArn),
        Utilization: output.Utilization != null ? de_SavingsPlansUtilization(output.Utilization, context) : undefined,
    };
};
const de_SavingsPlansUtilizationDetails = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_SavingsPlansUtilizationDetail(entry, context);
    });
    return retVal;
};
const de_SavingsPlansUtilizationsByTime = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_SavingsPlansUtilizationByTime(entry, context);
    });
    return retVal;
};
const de_ServiceQuotaExceededException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const de_ServiceSpecification = (output, context) => {
    return {
        EC2Specification: output.EC2Specification != null ? de_EC2Specification(output.EC2Specification, context) : undefined,
    };
};
const de_StartSavingsPlansPurchaseRecommendationGenerationResponse = (output, context) => {
    return {
        EstimatedCompletionTime: __expectString(output.EstimatedCompletionTime),
        GenerationStartedTime: __expectString(output.GenerationStartedTime),
        RecommendationId: __expectString(output.RecommendationId),
    };
};
const de_Subscriber = (output, context) => {
    return {
        Address: __expectString(output.Address),
        Status: __expectString(output.Status),
        Type: __expectString(output.Type),
    };
};
const de_Subscribers = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_Subscriber(entry, context);
    });
    return retVal;
};
const de_TagList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const de_TagResourceResponse = (output, context) => {
    return {};
};
const de_TagValues = (output, context) => {
    return {
        Key: __expectString(output.Key),
        MatchOptions: output.MatchOptions != null ? de_MatchOptions(output.MatchOptions, context) : undefined,
        Values: output.Values != null ? de_Values(output.Values, context) : undefined,
    };
};
const de_TagValuesList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_TagValues(entry, context);
    });
    return retVal;
};
const de_TargetInstance = (output, context) => {
    return {
        CurrencyCode: __expectString(output.CurrencyCode),
        DefaultTargetInstance: __expectBoolean(output.DefaultTargetInstance),
        EstimatedMonthlyCost: __expectString(output.EstimatedMonthlyCost),
        EstimatedMonthlySavings: __expectString(output.EstimatedMonthlySavings),
        ExpectedResourceUtilization: output.ExpectedResourceUtilization != null
            ? de_ResourceUtilization(output.ExpectedResourceUtilization, context)
            : undefined,
        PlatformDifferences: output.PlatformDifferences != null ? de_PlatformDifferences(output.PlatformDifferences, context) : undefined,
        ResourceDetails: output.ResourceDetails != null ? de_ResourceDetails(output.ResourceDetails, context) : undefined,
    };
};
const de_TargetInstancesList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_TargetInstance(entry, context);
    });
    return retVal;
};
const de_TerminateRecommendationDetail = (output, context) => {
    return {
        CurrencyCode: __expectString(output.CurrencyCode),
        EstimatedMonthlySavings: __expectString(output.EstimatedMonthlySavings),
    };
};
const de_TooManyTagsException = (output, context) => {
    return {
        Message: __expectString(output.Message),
        ResourceName: __expectString(output.ResourceName),
    };
};
const de_UnknownMonitorException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const de_UnknownSubscriptionException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const de_UnresolvableUsageUnitException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const de_UntagResourceResponse = (output, context) => {
    return {};
};
const de_UpdateAnomalyMonitorResponse = (output, context) => {
    return {
        MonitorArn: __expectString(output.MonitorArn),
    };
};
const de_UpdateAnomalySubscriptionResponse = (output, context) => {
    return {
        SubscriptionArn: __expectString(output.SubscriptionArn),
    };
};
const de_UpdateCostAllocationTagsStatusError = (output, context) => {
    return {
        Code: __expectString(output.Code),
        Message: __expectString(output.Message),
        TagKey: __expectString(output.TagKey),
    };
};
const de_UpdateCostAllocationTagsStatusErrors = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_UpdateCostAllocationTagsStatusError(entry, context);
    });
    return retVal;
};
const de_UpdateCostAllocationTagsStatusResponse = (output, context) => {
    return {
        Errors: output.Errors != null ? de_UpdateCostAllocationTagsStatusErrors(output.Errors, context) : undefined,
    };
};
const de_UpdateCostCategoryDefinitionResponse = (output, context) => {
    return {
        CostCategoryArn: __expectString(output.CostCategoryArn),
        EffectiveStart: __expectString(output.EffectiveStart),
    };
};
const de_UtilizationByTime = (output, context) => {
    return {
        Groups: output.Groups != null ? de_ReservationUtilizationGroups(output.Groups, context) : undefined,
        TimePeriod: output.TimePeriod != null ? de_DateInterval(output.TimePeriod, context) : undefined,
        Total: output.Total != null ? de_ReservationAggregates(output.Total, context) : undefined,
    };
};
const de_UtilizationsByTime = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return de_UtilizationByTime(entry, context);
    });
    return retVal;
};
const de_Values = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const deserializeMetadata = (output) => ({
    httpStatusCode: output.statusCode,
    requestId: output.headers["x-amzn-requestid"] ?? output.headers["x-amzn-request-id"] ?? output.headers["x-amz-request-id"],
    extendedRequestId: output.headers["x-amz-id-2"],
    cfId: output.headers["x-amz-cf-id"],
});
const collectBody = (streamBody = new Uint8Array(), context) => {
    if (streamBody instanceof Uint8Array) {
        return Promise.resolve(streamBody);
    }
    return context.streamCollector(streamBody) || Promise.resolve(new Uint8Array());
};
const collectBodyString = (streamBody, context) => collectBody(streamBody, context).then((body) => context.utf8Encoder(body));
const buildHttpRpcRequest = async (context, headers, path, resolvedHostname, body) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const contents = {
        protocol,
        hostname,
        port,
        method: "POST",
        path: basePath.endsWith("/") ? basePath.slice(0, -1) + path : basePath + path,
        headers,
    };
    if (resolvedHostname !== undefined) {
        contents.hostname = resolvedHostname;
    }
    if (body !== undefined) {
        contents.body = body;
    }
    return new __HttpRequest(contents);
};
const parseBody = (streamBody, context) => collectBodyString(streamBody, context).then((encoded) => {
    if (encoded.length) {
        return JSON.parse(encoded);
    }
    return {};
});
const parseErrorBody = async (errorBody, context) => {
    const value = await parseBody(errorBody, context);
    value.message = value.message ?? value.Message;
    return value;
};
const loadRestJsonErrorCode = (output, data) => {
    const findKey = (object, key) => Object.keys(object).find((k) => k.toLowerCase() === key.toLowerCase());
    const sanitizeErrorCode = (rawValue) => {
        let cleanValue = rawValue;
        if (typeof cleanValue === "number") {
            cleanValue = cleanValue.toString();
        }
        if (cleanValue.indexOf(",") >= 0) {
            cleanValue = cleanValue.split(",")[0];
        }
        if (cleanValue.indexOf(":") >= 0) {
            cleanValue = cleanValue.split(":")[0];
        }
        if (cleanValue.indexOf("#") >= 0) {
            cleanValue = cleanValue.split("#")[1];
        }
        return cleanValue;
    };
    const headerKey = findKey(output.headers, "x-amzn-errortype");
    if (headerKey !== undefined) {
        return sanitizeErrorCode(output.headers[headerKey]);
    }
    if (data.code !== undefined) {
        return sanitizeErrorCode(data.code);
    }
    if (data["__type"] !== undefined) {
        return sanitizeErrorCode(data["__type"]);
    }
};
